Module javafx.controls
Package javafx.scene.control.skin

# Class TreeViewSkin<T>

java.lang.Object
javafx.scene.control.SkinBase<TreeView<T>>
javafx.scene.control.skin.VirtualContainerBase<TreeView<T>,TreeCell<T>>
javafx.scene.control.skin.TreeViewSkin<T>

All Implemented Interfaces:
  `Skin<TreeView<T>>`

public class TreeViewSkin<T> extends VirtualContainerBase<TreeView<T>,TreeCell<T>>
Default skin implementation for the `TreeView` control.

Since:
  9
See Also:
  - `TreeView`

## Constructor Summary

Constructors
Constructor
Description
`TreeViewSkin(TreeView control)`
Creates a new TreeViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.

## Method Summary

Modifier and Type
Method
Description
`protected double`
`computePrefHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)`
Calculates the preferred height of this `SkinBase`.
`protected double`
`computePrefWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)`
Calculates the preferred width of this `SkinBase`.
`void`
`dispose()`
Called by a Skinnable when the Skin is replaced on the Skinnable.
`protected void`
`executeAccessibleAction(AccessibleAction action, Object... parameters)`
This method is called by the assistive technology to request the action indicated by the argument should be executed.
`protected int`
`getItemCount()`
Returns the total number of items in this container, including those that are currently hidden because they are out of view.
`protected void`
`layoutChildren(double x, double y, double w, double h)`
Called during the layout pass of the scenegraph.
`protected Object`
`queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)`
This method is called by the assistive technology to request the value for an attribute.
`protected void`
`updateItemCount()`
This method is called when it is possible that the item count has changed (i.e.

### Methods inherited from class javafx.scene.control.skin.VirtualContainerBase

`createVirtualFlow, getVirtualFlow, markItemCountDirty`

### Methods inherited from class javafx.scene.control.SkinBase

`computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, consumeMouseEvents, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, registerChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TreeViewSkin

public TreeViewSkin(TreeView control)
Creates a new TreeViewSkin instance, installing the necessary child nodes into the Control `children` list, as well as the necessary input mappings for handling key, mouse, etc events.

Parameters:
  `control` - The control that this skin should be installed onto.

## Method Details

### dispose

public void dispose()
Called by a Skinnable when the Skin is replaced on the Skinnable. This method allows a Skin to implement any logic necessary to clean up itself after the Skin is no longer needed. It may be used to release native resources. The methods `Skin.getSkinnable()` and `Skin.getNode()` should return null following a call to dispose. Calling dispose twice has no effect.

Specified by:
  `dispose` in interface `Skin<T>`
Overrides:
  `dispose` in class `SkinBase<TreeView<T>>`

### computePrefWidth

protected double computePrefWidth(double height, double topInset, double rightInset, double bottomInset, double leftInset)
Calculates the preferred width of this `SkinBase`. The default implementation calculates this width as the width of the area occupied by its managed children when they are positioned at their current positions at their preferred widths.

Overrides:
  `computePrefWidth` in class `SkinBase<TreeView<T>>`
Parameters:
  `height` - the height that should be used if preferred width depends on it
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  the calculated preferred width

### computePrefHeight

protected double computePrefHeight(double width, double topInset, double rightInset, double bottomInset, double leftInset)
Calculates the preferred height of this `SkinBase`. The default implementation calculates this height as the height of the area occupied by its managed children when they are positioned at their current positions at their preferred heights.

Overrides:
  `computePrefHeight` in class `SkinBase<TreeView<T>>`
Parameters:
  `width` - the width that should be used if preferred height depends on it
  `topInset` - the pixel snapped top inset
  `rightInset` - the pixel snapped right inset
  `bottomInset` - the pixel snapped bottom inset
  `leftInset` - the pixel snapped left inset
Returns:
  the calculated preferred height

### layoutChildren

protected void layoutChildren(double x, double y, double w, double h)
Called during the layout pass of the scenegraph.

Overrides:
  `layoutChildren` in class `VirtualContainerBase<TreeView<T>,TreeCell<T>>`
Parameters:
  `x` - the x position
  `y` - the y position
  `w` - the width
  `h` - the height

### queryAccessibleAttribute

protected Object queryAccessibleAttribute(AccessibleAttribute attribute, Object... parameters)
This method is called by the assistive technology to request the value for an attribute.

This method is commonly overridden by subclasses to implement attributes that are required for a specific role.
If a particular attribute is not handled, the superclass implementation must be called.

Overrides:
  `queryAccessibleAttribute` in class `SkinBase<TreeView<T>>`
Parameters:
  `attribute` - the requested attribute
  `parameters` - optional list of parameters
Returns:
  the value for the requested attribute
See Also:
  - `AccessibleAttribute`
  - `Node.queryAccessibleAttribute(javafx.scene.AccessibleAttribute, java.lang.Object...)`

### executeAccessibleAction

protected void executeAccessibleAction(AccessibleAction action, Object... parameters)
This method is called by the assistive technology to request the action indicated by the argument should be executed.

This method is commonly overridden by subclasses to implement action that are required for a specific role.
If a particular action is not handled, the superclass implementation must be called.

Overrides:
  `executeAccessibleAction` in class `SkinBase<TreeView<T>>`
Parameters:
  `action` - the action to execute
  `parameters` - optional list of parameters
See Also:
  - `AccessibleAction`
  - `Node.executeAccessibleAction(javafx.scene.AccessibleAction, java.lang.Object...)`

### getItemCount

protected int getItemCount()
Returns the total number of items in this container, including those that are currently hidden because they are out of view.

Specified by:
  `getItemCount` in class `VirtualContainerBase<TreeView<T>,TreeCell<T>>`
Returns:
  the total number of items in this container

### updateItemCount

protected void updateItemCount()
This method is called when it is possible that the item count has changed (i.e. scrolling has occurred, the control has resized, etc). This method should recalculate the item count and store that for future use by the `VirtualContainerBase.getItemCount()` method.

Specified by:
  `updateItemCount` in class `VirtualContainerBase<TreeView<T>,TreeCell<T>>`